// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: protocol.proto

#ifndef GOOGLE_PROTOBUF_INCLUDED_protocol_2eproto
#define GOOGLE_PROTOBUF_INCLUDED_protocol_2eproto

#include <limits>
#include <string>

#include <google/protobuf/port_def.inc>
#if PROTOBUF_VERSION < 3008000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers. Please update
#error your headers.
#endif
#if 3008000 < PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers. Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/port_undef.inc>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/inlined_string_field.h>
#include <google/protobuf/metadata.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include <google/protobuf/unknown_field_set.h>
#include <google/protobuf/any.pb.h>
// @@protoc_insertion_point(includes)
#include <google/protobuf/port_def.inc>
#define PROTOBUF_INTERNAL_EXPORT_protocol_2eproto
PROTOBUF_NAMESPACE_OPEN
namespace internal {
class AnyMetadata;
}  // namespace internal
PROTOBUF_NAMESPACE_CLOSE

// Internal implementation detail -- do not use these members.
struct TableStruct_protocol_2eproto {
  static const ::PROTOBUF_NAMESPACE_ID::internal::ParseTableField entries[]
    PROTOBUF_SECTION_VARIABLE(protodesc_cold);
  static const ::PROTOBUF_NAMESPACE_ID::internal::AuxillaryParseTableField aux[]
    PROTOBUF_SECTION_VARIABLE(protodesc_cold);
  static const ::PROTOBUF_NAMESPACE_ID::internal::ParseTable schema[4]
    PROTOBUF_SECTION_VARIABLE(protodesc_cold);
  static const ::PROTOBUF_NAMESPACE_ID::internal::FieldMetadata field_metadata[];
  static const ::PROTOBUF_NAMESPACE_ID::internal::SerializationTable serialization_table[];
  static const ::PROTOBUF_NAMESPACE_ID::uint32 offsets[];
};
extern const ::PROTOBUF_NAMESPACE_ID::internal::DescriptorTable descriptor_table_protocol_2eproto;
namespace krpc {
namespace rpc {
namespace protocol {
class Request;
class RequestDefaultTypeInternal;
extern RequestDefaultTypeInternal _Request_default_instance_;
class Request_Procedure;
class Request_ProcedureDefaultTypeInternal;
extern Request_ProcedureDefaultTypeInternal _Request_Procedure_default_instance_;
class Response;
class ResponseDefaultTypeInternal;
extern ResponseDefaultTypeInternal _Response_default_instance_;
class Response_Error;
class Response_ErrorDefaultTypeInternal;
extern Response_ErrorDefaultTypeInternal _Response_Error_default_instance_;
}  // namespace protocol
}  // namespace rpc
}  // namespace krpc
PROTOBUF_NAMESPACE_OPEN
template<> ::krpc::rpc::protocol::Request* Arena::CreateMaybeMessage<::krpc::rpc::protocol::Request>(Arena*);
template<> ::krpc::rpc::protocol::Request_Procedure* Arena::CreateMaybeMessage<::krpc::rpc::protocol::Request_Procedure>(Arena*);
template<> ::krpc::rpc::protocol::Response* Arena::CreateMaybeMessage<::krpc::rpc::protocol::Response>(Arena*);
template<> ::krpc::rpc::protocol::Response_Error* Arena::CreateMaybeMessage<::krpc::rpc::protocol::Response_Error>(Arena*);
PROTOBUF_NAMESPACE_CLOSE
namespace krpc {
namespace rpc {
namespace protocol {

// ===================================================================

class Request_Procedure :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:krpc.rpc.protocol.Request.Procedure) */ {
 public:
  Request_Procedure();
  virtual ~Request_Procedure();

  Request_Procedure(const Request_Procedure& from);
  Request_Procedure(Request_Procedure&& from) noexcept
    : Request_Procedure() {
    *this = ::std::move(from);
  }

  inline Request_Procedure& operator=(const Request_Procedure& from) {
    CopyFrom(from);
    return *this;
  }
  inline Request_Procedure& operator=(Request_Procedure&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const Request_Procedure& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const Request_Procedure* internal_default_instance() {
    return reinterpret_cast<const Request_Procedure*>(
               &_Request_Procedure_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    0;

  void Swap(Request_Procedure* other);
  friend void swap(Request_Procedure& a, Request_Procedure& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline Request_Procedure* New() const final {
    return CreateMaybeMessage<Request_Procedure>(nullptr);
  }

  Request_Procedure* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<Request_Procedure>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const Request_Procedure& from);
  void MergeFrom(const Request_Procedure& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  #if GOOGLE_PROTOBUF_ENABLE_EXPERIMENTAL_PARSER
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  #else
  bool MergePartialFromCodedStream(
      ::PROTOBUF_NAMESPACE_ID::io::CodedInputStream* input) final;
  #endif  // GOOGLE_PROTOBUF_ENABLE_EXPERIMENTAL_PARSER
  void SerializeWithCachedSizes(
      ::PROTOBUF_NAMESPACE_ID::io::CodedOutputStream* output) const final;
  ::PROTOBUF_NAMESPACE_ID::uint8* InternalSerializeWithCachedSizesToArray(
      ::PROTOBUF_NAMESPACE_ID::uint8* target) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(Request_Procedure* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "krpc.rpc.protocol.Request.Procedure";
  }
  private:
  inline ::PROTOBUF_NAMESPACE_ID::Arena* GetArenaNoVirtual() const {
    return nullptr;
  }
  inline void* MaybeArenaPtr() const {
    return nullptr;
  }
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_protocol_2eproto);
    return ::descriptor_table_protocol_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated .google.protobuf.Any params = 4;
  int params_size() const;
  void clear_params();
  static const int kParamsFieldNumber = 4;
  PROTOBUF_NAMESPACE_ID::Any* mutable_params(int index);
  ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< PROTOBUF_NAMESPACE_ID::Any >*
      mutable_params();
  const PROTOBUF_NAMESPACE_ID::Any& params(int index) const;
  PROTOBUF_NAMESPACE_ID::Any* add_params();
  const ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< PROTOBUF_NAMESPACE_ID::Any >&
      params() const;

  // string type = 1;
  void clear_type();
  static const int kTypeFieldNumber = 1;
  const std::string& type() const;
  void set_type(const std::string& value);
  void set_type(std::string&& value);
  void set_type(const char* value);
  void set_type(const char* value, size_t size);
  std::string* mutable_type();
  std::string* release_type();
  void set_allocated_type(std::string* type);

  // string name = 2;
  void clear_name();
  static const int kNameFieldNumber = 2;
  const std::string& name() const;
  void set_name(const std::string& value);
  void set_name(std::string&& value);
  void set_name(const char* value);
  void set_name(const char* value, size_t size);
  std::string* mutable_name();
  std::string* release_name();
  void set_allocated_name(std::string* name);

  // bool static = 3;
  void clear_static_();
  static const int kStaticFieldNumber = 3;
  bool static_() const;
  void set_static_(bool value);

  // @@protoc_insertion_point(class_scope:krpc.rpc.protocol.Request.Procedure)
 private:
  class HasBitSetters;

  ::PROTOBUF_NAMESPACE_ID::internal::InternalMetadataWithArena _internal_metadata_;
  ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< PROTOBUF_NAMESPACE_ID::Any > params_;
  ::PROTOBUF_NAMESPACE_ID::internal::ArenaStringPtr type_;
  ::PROTOBUF_NAMESPACE_ID::internal::ArenaStringPtr name_;
  bool static__;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_protocol_2eproto;
};
// -------------------------------------------------------------------

class Request :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:krpc.rpc.protocol.Request) */ {
 public:
  Request();
  virtual ~Request();

  Request(const Request& from);
  Request(Request&& from) noexcept
    : Request() {
    *this = ::std::move(from);
  }

  inline Request& operator=(const Request& from) {
    CopyFrom(from);
    return *this;
  }
  inline Request& operator=(Request&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const Request& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const Request* internal_default_instance() {
    return reinterpret_cast<const Request*>(
               &_Request_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    1;

  void Swap(Request* other);
  friend void swap(Request& a, Request& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline Request* New() const final {
    return CreateMaybeMessage<Request>(nullptr);
  }

  Request* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<Request>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const Request& from);
  void MergeFrom(const Request& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  #if GOOGLE_PROTOBUF_ENABLE_EXPERIMENTAL_PARSER
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  #else
  bool MergePartialFromCodedStream(
      ::PROTOBUF_NAMESPACE_ID::io::CodedInputStream* input) final;
  #endif  // GOOGLE_PROTOBUF_ENABLE_EXPERIMENTAL_PARSER
  void SerializeWithCachedSizes(
      ::PROTOBUF_NAMESPACE_ID::io::CodedOutputStream* output) const final;
  ::PROTOBUF_NAMESPACE_ID::uint8* InternalSerializeWithCachedSizesToArray(
      ::PROTOBUF_NAMESPACE_ID::uint8* target) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(Request* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "krpc.rpc.protocol.Request";
  }
  private:
  inline ::PROTOBUF_NAMESPACE_ID::Arena* GetArenaNoVirtual() const {
    return nullptr;
  }
  inline void* MaybeArenaPtr() const {
    return nullptr;
  }
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_protocol_2eproto);
    return ::descriptor_table_protocol_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  typedef Request_Procedure Procedure;

  // accessors -------------------------------------------------------

  // .krpc.rpc.protocol.Request.Procedure procedure = 2;
  bool has_procedure() const;
  void clear_procedure();
  static const int kProcedureFieldNumber = 2;
  const ::krpc::rpc::protocol::Request_Procedure& procedure() const;
  ::krpc::rpc::protocol::Request_Procedure* release_procedure();
  ::krpc::rpc::protocol::Request_Procedure* mutable_procedure();
  void set_allocated_procedure(::krpc::rpc::protocol::Request_Procedure* procedure);

  // uint64 identifier = 1;
  void clear_identifier();
  static const int kIdentifierFieldNumber = 1;
  ::PROTOBUF_NAMESPACE_ID::uint64 identifier() const;
  void set_identifier(::PROTOBUF_NAMESPACE_ID::uint64 value);

  // @@protoc_insertion_point(class_scope:krpc.rpc.protocol.Request)
 private:
  class HasBitSetters;

  ::PROTOBUF_NAMESPACE_ID::internal::InternalMetadataWithArena _internal_metadata_;
  ::krpc::rpc::protocol::Request_Procedure* procedure_;
  ::PROTOBUF_NAMESPACE_ID::uint64 identifier_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_protocol_2eproto;
};
// -------------------------------------------------------------------

class Response_Error :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:krpc.rpc.protocol.Response.Error) */ {
 public:
  Response_Error();
  virtual ~Response_Error();

  Response_Error(const Response_Error& from);
  Response_Error(Response_Error&& from) noexcept
    : Response_Error() {
    *this = ::std::move(from);
  }

  inline Response_Error& operator=(const Response_Error& from) {
    CopyFrom(from);
    return *this;
  }
  inline Response_Error& operator=(Response_Error&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const Response_Error& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const Response_Error* internal_default_instance() {
    return reinterpret_cast<const Response_Error*>(
               &_Response_Error_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    2;

  void Swap(Response_Error* other);
  friend void swap(Response_Error& a, Response_Error& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline Response_Error* New() const final {
    return CreateMaybeMessage<Response_Error>(nullptr);
  }

  Response_Error* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<Response_Error>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const Response_Error& from);
  void MergeFrom(const Response_Error& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  #if GOOGLE_PROTOBUF_ENABLE_EXPERIMENTAL_PARSER
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  #else
  bool MergePartialFromCodedStream(
      ::PROTOBUF_NAMESPACE_ID::io::CodedInputStream* input) final;
  #endif  // GOOGLE_PROTOBUF_ENABLE_EXPERIMENTAL_PARSER
  void SerializeWithCachedSizes(
      ::PROTOBUF_NAMESPACE_ID::io::CodedOutputStream* output) const final;
  ::PROTOBUF_NAMESPACE_ID::uint8* InternalSerializeWithCachedSizesToArray(
      ::PROTOBUF_NAMESPACE_ID::uint8* target) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(Response_Error* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "krpc.rpc.protocol.Response.Error";
  }
  private:
  inline ::PROTOBUF_NAMESPACE_ID::Arena* GetArenaNoVirtual() const {
    return nullptr;
  }
  inline void* MaybeArenaPtr() const {
    return nullptr;
  }
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_protocol_2eproto);
    return ::descriptor_table_protocol_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string type = 1;
  void clear_type();
  static const int kTypeFieldNumber = 1;
  const std::string& type() const;
  void set_type(const std::string& value);
  void set_type(std::string&& value);
  void set_type(const char* value);
  void set_type(const char* value, size_t size);
  std::string* mutable_type();
  std::string* release_type();
  void set_allocated_type(std::string* type);

  // string message = 2;
  void clear_message();
  static const int kMessageFieldNumber = 2;
  const std::string& message() const;
  void set_message(const std::string& value);
  void set_message(std::string&& value);
  void set_message(const char* value);
  void set_message(const char* value, size_t size);
  std::string* mutable_message();
  std::string* release_message();
  void set_allocated_message(std::string* message);

  // string stack_trace = 3;
  void clear_stack_trace();
  static const int kStackTraceFieldNumber = 3;
  const std::string& stack_trace() const;
  void set_stack_trace(const std::string& value);
  void set_stack_trace(std::string&& value);
  void set_stack_trace(const char* value);
  void set_stack_trace(const char* value, size_t size);
  std::string* mutable_stack_trace();
  std::string* release_stack_trace();
  void set_allocated_stack_trace(std::string* stack_trace);

  // @@protoc_insertion_point(class_scope:krpc.rpc.protocol.Response.Error)
 private:
  class HasBitSetters;

  ::PROTOBUF_NAMESPACE_ID::internal::InternalMetadataWithArena _internal_metadata_;
  ::PROTOBUF_NAMESPACE_ID::internal::ArenaStringPtr type_;
  ::PROTOBUF_NAMESPACE_ID::internal::ArenaStringPtr message_;
  ::PROTOBUF_NAMESPACE_ID::internal::ArenaStringPtr stack_trace_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_protocol_2eproto;
};
// -------------------------------------------------------------------

class Response :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:krpc.rpc.protocol.Response) */ {
 public:
  Response();
  virtual ~Response();

  Response(const Response& from);
  Response(Response&& from) noexcept
    : Response() {
    *this = ::std::move(from);
  }

  inline Response& operator=(const Response& from) {
    CopyFrom(from);
    return *this;
  }
  inline Response& operator=(Response&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const Response& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const Response* internal_default_instance() {
    return reinterpret_cast<const Response*>(
               &_Response_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    3;

  void Swap(Response* other);
  friend void swap(Response& a, Response& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline Response* New() const final {
    return CreateMaybeMessage<Response>(nullptr);
  }

  Response* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<Response>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const Response& from);
  void MergeFrom(const Response& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  #if GOOGLE_PROTOBUF_ENABLE_EXPERIMENTAL_PARSER
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  #else
  bool MergePartialFromCodedStream(
      ::PROTOBUF_NAMESPACE_ID::io::CodedInputStream* input) final;
  #endif  // GOOGLE_PROTOBUF_ENABLE_EXPERIMENTAL_PARSER
  void SerializeWithCachedSizes(
      ::PROTOBUF_NAMESPACE_ID::io::CodedOutputStream* output) const final;
  ::PROTOBUF_NAMESPACE_ID::uint8* InternalSerializeWithCachedSizesToArray(
      ::PROTOBUF_NAMESPACE_ID::uint8* target) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(Response* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "krpc.rpc.protocol.Response";
  }
  private:
  inline ::PROTOBUF_NAMESPACE_ID::Arena* GetArenaNoVirtual() const {
    return nullptr;
  }
  inline void* MaybeArenaPtr() const {
    return nullptr;
  }
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_protocol_2eproto);
    return ::descriptor_table_protocol_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  typedef Response_Error Error;

  // accessors -------------------------------------------------------

  // .google.protobuf.Any result = 2;
  bool has_result() const;
  void clear_result();
  static const int kResultFieldNumber = 2;
  const PROTOBUF_NAMESPACE_ID::Any& result() const;
  PROTOBUF_NAMESPACE_ID::Any* release_result();
  PROTOBUF_NAMESPACE_ID::Any* mutable_result();
  void set_allocated_result(PROTOBUF_NAMESPACE_ID::Any* result);

  // .krpc.rpc.protocol.Response.Error error = 3;
  bool has_error() const;
  void clear_error();
  static const int kErrorFieldNumber = 3;
  const ::krpc::rpc::protocol::Response_Error& error() const;
  ::krpc::rpc::protocol::Response_Error* release_error();
  ::krpc::rpc::protocol::Response_Error* mutable_error();
  void set_allocated_error(::krpc::rpc::protocol::Response_Error* error);

  // uint64 identifier = 1;
  void clear_identifier();
  static const int kIdentifierFieldNumber = 1;
  ::PROTOBUF_NAMESPACE_ID::uint64 identifier() const;
  void set_identifier(::PROTOBUF_NAMESPACE_ID::uint64 value);

  // @@protoc_insertion_point(class_scope:krpc.rpc.protocol.Response)
 private:
  class HasBitSetters;

  ::PROTOBUF_NAMESPACE_ID::internal::InternalMetadataWithArena _internal_metadata_;
  PROTOBUF_NAMESPACE_ID::Any* result_;
  ::krpc::rpc::protocol::Response_Error* error_;
  ::PROTOBUF_NAMESPACE_ID::uint64 identifier_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_protocol_2eproto;
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// Request_Procedure

// string type = 1;
inline void Request_Procedure::clear_type() {
  type_.ClearToEmptyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline const std::string& Request_Procedure::type() const {
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Request.Procedure.type)
  return type_.GetNoArena();
}
inline void Request_Procedure::set_type(const std::string& value) {
  
  type_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:krpc.rpc.protocol.Request.Procedure.type)
}
inline void Request_Procedure::set_type(std::string&& value) {
  
  type_.SetNoArena(
    &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:krpc.rpc.protocol.Request.Procedure.type)
}
inline void Request_Procedure::set_type(const char* value) {
  GOOGLE_DCHECK(value != nullptr);
  
  type_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:krpc.rpc.protocol.Request.Procedure.type)
}
inline void Request_Procedure::set_type(const char* value, size_t size) {
  
  type_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:krpc.rpc.protocol.Request.Procedure.type)
}
inline std::string* Request_Procedure::mutable_type() {
  
  // @@protoc_insertion_point(field_mutable:krpc.rpc.protocol.Request.Procedure.type)
  return type_.MutableNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline std::string* Request_Procedure::release_type() {
  // @@protoc_insertion_point(field_release:krpc.rpc.protocol.Request.Procedure.type)
  
  return type_.ReleaseNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline void Request_Procedure::set_allocated_type(std::string* type) {
  if (type != nullptr) {
    
  } else {
    
  }
  type_.SetAllocatedNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), type);
  // @@protoc_insertion_point(field_set_allocated:krpc.rpc.protocol.Request.Procedure.type)
}

// string name = 2;
inline void Request_Procedure::clear_name() {
  name_.ClearToEmptyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline const std::string& Request_Procedure::name() const {
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Request.Procedure.name)
  return name_.GetNoArena();
}
inline void Request_Procedure::set_name(const std::string& value) {
  
  name_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:krpc.rpc.protocol.Request.Procedure.name)
}
inline void Request_Procedure::set_name(std::string&& value) {
  
  name_.SetNoArena(
    &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:krpc.rpc.protocol.Request.Procedure.name)
}
inline void Request_Procedure::set_name(const char* value) {
  GOOGLE_DCHECK(value != nullptr);
  
  name_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:krpc.rpc.protocol.Request.Procedure.name)
}
inline void Request_Procedure::set_name(const char* value, size_t size) {
  
  name_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:krpc.rpc.protocol.Request.Procedure.name)
}
inline std::string* Request_Procedure::mutable_name() {
  
  // @@protoc_insertion_point(field_mutable:krpc.rpc.protocol.Request.Procedure.name)
  return name_.MutableNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline std::string* Request_Procedure::release_name() {
  // @@protoc_insertion_point(field_release:krpc.rpc.protocol.Request.Procedure.name)
  
  return name_.ReleaseNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline void Request_Procedure::set_allocated_name(std::string* name) {
  if (name != nullptr) {
    
  } else {
    
  }
  name_.SetAllocatedNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), name);
  // @@protoc_insertion_point(field_set_allocated:krpc.rpc.protocol.Request.Procedure.name)
}

// bool static = 3;
inline void Request_Procedure::clear_static_() {
  static__ = false;
}
inline bool Request_Procedure::static_() const {
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Request.Procedure.static)
  return static__;
}
inline void Request_Procedure::set_static_(bool value) {
  
  static__ = value;
  // @@protoc_insertion_point(field_set:krpc.rpc.protocol.Request.Procedure.static)
}

// repeated .google.protobuf.Any params = 4;
inline int Request_Procedure::params_size() const {
  return params_.size();
}
inline PROTOBUF_NAMESPACE_ID::Any* Request_Procedure::mutable_params(int index) {
  // @@protoc_insertion_point(field_mutable:krpc.rpc.protocol.Request.Procedure.params)
  return params_.Mutable(index);
}
inline ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< PROTOBUF_NAMESPACE_ID::Any >*
Request_Procedure::mutable_params() {
  // @@protoc_insertion_point(field_mutable_list:krpc.rpc.protocol.Request.Procedure.params)
  return &params_;
}
inline const PROTOBUF_NAMESPACE_ID::Any& Request_Procedure::params(int index) const {
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Request.Procedure.params)
  return params_.Get(index);
}
inline PROTOBUF_NAMESPACE_ID::Any* Request_Procedure::add_params() {
  // @@protoc_insertion_point(field_add:krpc.rpc.protocol.Request.Procedure.params)
  return params_.Add();
}
inline const ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< PROTOBUF_NAMESPACE_ID::Any >&
Request_Procedure::params() const {
  // @@protoc_insertion_point(field_list:krpc.rpc.protocol.Request.Procedure.params)
  return params_;
}

// -------------------------------------------------------------------

// Request

// uint64 identifier = 1;
inline void Request::clear_identifier() {
  identifier_ = PROTOBUF_ULONGLONG(0);
}
inline ::PROTOBUF_NAMESPACE_ID::uint64 Request::identifier() const {
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Request.identifier)
  return identifier_;
}
inline void Request::set_identifier(::PROTOBUF_NAMESPACE_ID::uint64 value) {
  
  identifier_ = value;
  // @@protoc_insertion_point(field_set:krpc.rpc.protocol.Request.identifier)
}

// .krpc.rpc.protocol.Request.Procedure procedure = 2;
inline bool Request::has_procedure() const {
  return this != internal_default_instance() && procedure_ != nullptr;
}
inline void Request::clear_procedure() {
  if (GetArenaNoVirtual() == nullptr && procedure_ != nullptr) {
    delete procedure_;
  }
  procedure_ = nullptr;
}
inline const ::krpc::rpc::protocol::Request_Procedure& Request::procedure() const {
  const ::krpc::rpc::protocol::Request_Procedure* p = procedure_;
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Request.procedure)
  return p != nullptr ? *p : *reinterpret_cast<const ::krpc::rpc::protocol::Request_Procedure*>(
      &::krpc::rpc::protocol::_Request_Procedure_default_instance_);
}
inline ::krpc::rpc::protocol::Request_Procedure* Request::release_procedure() {
  // @@protoc_insertion_point(field_release:krpc.rpc.protocol.Request.procedure)
  
  ::krpc::rpc::protocol::Request_Procedure* temp = procedure_;
  procedure_ = nullptr;
  return temp;
}
inline ::krpc::rpc::protocol::Request_Procedure* Request::mutable_procedure() {
  
  if (procedure_ == nullptr) {
    auto* p = CreateMaybeMessage<::krpc::rpc::protocol::Request_Procedure>(GetArenaNoVirtual());
    procedure_ = p;
  }
  // @@protoc_insertion_point(field_mutable:krpc.rpc.protocol.Request.procedure)
  return procedure_;
}
inline void Request::set_allocated_procedure(::krpc::rpc::protocol::Request_Procedure* procedure) {
  ::PROTOBUF_NAMESPACE_ID::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == nullptr) {
    delete procedure_;
  }
  if (procedure) {
    ::PROTOBUF_NAMESPACE_ID::Arena* submessage_arena = nullptr;
    if (message_arena != submessage_arena) {
      procedure = ::PROTOBUF_NAMESPACE_ID::internal::GetOwnedMessage(
          message_arena, procedure, submessage_arena);
    }
    
  } else {
    
  }
  procedure_ = procedure;
  // @@protoc_insertion_point(field_set_allocated:krpc.rpc.protocol.Request.procedure)
}

// -------------------------------------------------------------------

// Response_Error

// string type = 1;
inline void Response_Error::clear_type() {
  type_.ClearToEmptyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline const std::string& Response_Error::type() const {
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Response.Error.type)
  return type_.GetNoArena();
}
inline void Response_Error::set_type(const std::string& value) {
  
  type_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:krpc.rpc.protocol.Response.Error.type)
}
inline void Response_Error::set_type(std::string&& value) {
  
  type_.SetNoArena(
    &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:krpc.rpc.protocol.Response.Error.type)
}
inline void Response_Error::set_type(const char* value) {
  GOOGLE_DCHECK(value != nullptr);
  
  type_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:krpc.rpc.protocol.Response.Error.type)
}
inline void Response_Error::set_type(const char* value, size_t size) {
  
  type_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:krpc.rpc.protocol.Response.Error.type)
}
inline std::string* Response_Error::mutable_type() {
  
  // @@protoc_insertion_point(field_mutable:krpc.rpc.protocol.Response.Error.type)
  return type_.MutableNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline std::string* Response_Error::release_type() {
  // @@protoc_insertion_point(field_release:krpc.rpc.protocol.Response.Error.type)
  
  return type_.ReleaseNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline void Response_Error::set_allocated_type(std::string* type) {
  if (type != nullptr) {
    
  } else {
    
  }
  type_.SetAllocatedNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), type);
  // @@protoc_insertion_point(field_set_allocated:krpc.rpc.protocol.Response.Error.type)
}

// string message = 2;
inline void Response_Error::clear_message() {
  message_.ClearToEmptyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline const std::string& Response_Error::message() const {
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Response.Error.message)
  return message_.GetNoArena();
}
inline void Response_Error::set_message(const std::string& value) {
  
  message_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:krpc.rpc.protocol.Response.Error.message)
}
inline void Response_Error::set_message(std::string&& value) {
  
  message_.SetNoArena(
    &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:krpc.rpc.protocol.Response.Error.message)
}
inline void Response_Error::set_message(const char* value) {
  GOOGLE_DCHECK(value != nullptr);
  
  message_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:krpc.rpc.protocol.Response.Error.message)
}
inline void Response_Error::set_message(const char* value, size_t size) {
  
  message_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:krpc.rpc.protocol.Response.Error.message)
}
inline std::string* Response_Error::mutable_message() {
  
  // @@protoc_insertion_point(field_mutable:krpc.rpc.protocol.Response.Error.message)
  return message_.MutableNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline std::string* Response_Error::release_message() {
  // @@protoc_insertion_point(field_release:krpc.rpc.protocol.Response.Error.message)
  
  return message_.ReleaseNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline void Response_Error::set_allocated_message(std::string* message) {
  if (message != nullptr) {
    
  } else {
    
  }
  message_.SetAllocatedNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), message);
  // @@protoc_insertion_point(field_set_allocated:krpc.rpc.protocol.Response.Error.message)
}

// string stack_trace = 3;
inline void Response_Error::clear_stack_trace() {
  stack_trace_.ClearToEmptyNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline const std::string& Response_Error::stack_trace() const {
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Response.Error.stack_trace)
  return stack_trace_.GetNoArena();
}
inline void Response_Error::set_stack_trace(const std::string& value) {
  
  stack_trace_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:krpc.rpc.protocol.Response.Error.stack_trace)
}
inline void Response_Error::set_stack_trace(std::string&& value) {
  
  stack_trace_.SetNoArena(
    &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:krpc.rpc.protocol.Response.Error.stack_trace)
}
inline void Response_Error::set_stack_trace(const char* value) {
  GOOGLE_DCHECK(value != nullptr);
  
  stack_trace_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:krpc.rpc.protocol.Response.Error.stack_trace)
}
inline void Response_Error::set_stack_trace(const char* value, size_t size) {
  
  stack_trace_.SetNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:krpc.rpc.protocol.Response.Error.stack_trace)
}
inline std::string* Response_Error::mutable_stack_trace() {
  
  // @@protoc_insertion_point(field_mutable:krpc.rpc.protocol.Response.Error.stack_trace)
  return stack_trace_.MutableNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline std::string* Response_Error::release_stack_trace() {
  // @@protoc_insertion_point(field_release:krpc.rpc.protocol.Response.Error.stack_trace)
  
  return stack_trace_.ReleaseNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited());
}
inline void Response_Error::set_allocated_stack_trace(std::string* stack_trace) {
  if (stack_trace != nullptr) {
    
  } else {
    
  }
  stack_trace_.SetAllocatedNoArena(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), stack_trace);
  // @@protoc_insertion_point(field_set_allocated:krpc.rpc.protocol.Response.Error.stack_trace)
}

// -------------------------------------------------------------------

// Response

// uint64 identifier = 1;
inline void Response::clear_identifier() {
  identifier_ = PROTOBUF_ULONGLONG(0);
}
inline ::PROTOBUF_NAMESPACE_ID::uint64 Response::identifier() const {
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Response.identifier)
  return identifier_;
}
inline void Response::set_identifier(::PROTOBUF_NAMESPACE_ID::uint64 value) {
  
  identifier_ = value;
  // @@protoc_insertion_point(field_set:krpc.rpc.protocol.Response.identifier)
}

// .google.protobuf.Any result = 2;
inline bool Response::has_result() const {
  return this != internal_default_instance() && result_ != nullptr;
}
inline const PROTOBUF_NAMESPACE_ID::Any& Response::result() const {
  const PROTOBUF_NAMESPACE_ID::Any* p = result_;
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Response.result)
  return p != nullptr ? *p : *reinterpret_cast<const PROTOBUF_NAMESPACE_ID::Any*>(
      &PROTOBUF_NAMESPACE_ID::_Any_default_instance_);
}
inline PROTOBUF_NAMESPACE_ID::Any* Response::release_result() {
  // @@protoc_insertion_point(field_release:krpc.rpc.protocol.Response.result)
  
  PROTOBUF_NAMESPACE_ID::Any* temp = result_;
  result_ = nullptr;
  return temp;
}
inline PROTOBUF_NAMESPACE_ID::Any* Response::mutable_result() {
  
  if (result_ == nullptr) {
    auto* p = CreateMaybeMessage<PROTOBUF_NAMESPACE_ID::Any>(GetArenaNoVirtual());
    result_ = p;
  }
  // @@protoc_insertion_point(field_mutable:krpc.rpc.protocol.Response.result)
  return result_;
}
inline void Response::set_allocated_result(PROTOBUF_NAMESPACE_ID::Any* result) {
  ::PROTOBUF_NAMESPACE_ID::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == nullptr) {
    delete reinterpret_cast< ::PROTOBUF_NAMESPACE_ID::MessageLite*>(result_);
  }
  if (result) {
    ::PROTOBUF_NAMESPACE_ID::Arena* submessage_arena = nullptr;
    if (message_arena != submessage_arena) {
      result = ::PROTOBUF_NAMESPACE_ID::internal::GetOwnedMessage(
          message_arena, result, submessage_arena);
    }
    
  } else {
    
  }
  result_ = result;
  // @@protoc_insertion_point(field_set_allocated:krpc.rpc.protocol.Response.result)
}

// .krpc.rpc.protocol.Response.Error error = 3;
inline bool Response::has_error() const {
  return this != internal_default_instance() && error_ != nullptr;
}
inline void Response::clear_error() {
  if (GetArenaNoVirtual() == nullptr && error_ != nullptr) {
    delete error_;
  }
  error_ = nullptr;
}
inline const ::krpc::rpc::protocol::Response_Error& Response::error() const {
  const ::krpc::rpc::protocol::Response_Error* p = error_;
  // @@protoc_insertion_point(field_get:krpc.rpc.protocol.Response.error)
  return p != nullptr ? *p : *reinterpret_cast<const ::krpc::rpc::protocol::Response_Error*>(
      &::krpc::rpc::protocol::_Response_Error_default_instance_);
}
inline ::krpc::rpc::protocol::Response_Error* Response::release_error() {
  // @@protoc_insertion_point(field_release:krpc.rpc.protocol.Response.error)
  
  ::krpc::rpc::protocol::Response_Error* temp = error_;
  error_ = nullptr;
  return temp;
}
inline ::krpc::rpc::protocol::Response_Error* Response::mutable_error() {
  
  if (error_ == nullptr) {
    auto* p = CreateMaybeMessage<::krpc::rpc::protocol::Response_Error>(GetArenaNoVirtual());
    error_ = p;
  }
  // @@protoc_insertion_point(field_mutable:krpc.rpc.protocol.Response.error)
  return error_;
}
inline void Response::set_allocated_error(::krpc::rpc::protocol::Response_Error* error) {
  ::PROTOBUF_NAMESPACE_ID::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == nullptr) {
    delete error_;
  }
  if (error) {
    ::PROTOBUF_NAMESPACE_ID::Arena* submessage_arena = nullptr;
    if (message_arena != submessage_arena) {
      error = ::PROTOBUF_NAMESPACE_ID::internal::GetOwnedMessage(
          message_arena, error, submessage_arena);
    }
    
  } else {
    
  }
  error_ = error;
  // @@protoc_insertion_point(field_set_allocated:krpc.rpc.protocol.Response.error)
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__
// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

}  // namespace protocol
}  // namespace rpc
}  // namespace krpc

// @@protoc_insertion_point(global_scope)

#include <google/protobuf/port_undef.inc>
#endif  // GOOGLE_PROTOBUF_INCLUDED_GOOGLE_PROTOBUF_INCLUDED_protocol_2eproto
